\name{residuals.drc}

\alias{residuals.drc}

\title{Extracting residuals from model}

\description{
  'residuals' extracts residuals from an object of class 'drc'.
}

\usage{

  \method{residuals}{drc}(object, type = c("working", "standardised"), ...)

}

\arguments{
  \item{object}{an object of class 'drc'.}
  \item{type}{character string. The type of residual to be returned.}
  \item{...}{additional arguments.}
}

\value{
  Raw or standardised residuals extracted from 'object'.
}

\note{
  The 'standardised' residuals are available for least squares estimation
  with or without Box-Cox transformation or variance as a power of the
  mean.
}

\author{Christian Ritz}

\examples{

model1 <- multdrc(ryegrass)

## Displaying the residual plot (raw residuals)
plot(fitted(model1), residuals(model1))

## Using the standardised residuals
plot(fitted(model1), residuals(model1, type = "standard"))

rm(model1)

}
\keyword{models}
\keyword{nonlinear}
